Public Class Form1
  Friend bmpBitmap As Bitmap

  Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        CreateGridPiece(30, 30, True, True, True)
  End Sub

  Private Sub Form1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Me.Paint
    Me.BackgroundImage = bmpBitmap
  End Sub

  Private Sub CreateGridPiece(ByVal iWidth As Integer, ByVal iHeight As Integer, ByVal bCenter As Boolean, ByVal bWidthCenter As Boolean, ByVal bHeightCenter As Boolean)
    bmpBitmap = New Bitmap(iWidth, iHeight)

    Dim iBitmapWidth As Integer = bmpBitmap.Width - 1
    Dim iBitmapHeight As Integer = bmpBitmap.Height - 1

    For y As Integer = 0 To iBitmapWidth
      For x As Integer = 0 To iBitmapHeight
        bmpBitmap.SetPixel(x, y, Color.FromArgb(255, 143, 143, 143))
      Next
    Next

    bmpBitmap.SetPixel(0, 0, Color.FromArgb(255, 110, 110, 110))

    bmpBitmap.SetPixel(1, 0, Color.FromArgb(255, 180, 180, 180))
    bmpBitmap.SetPixel(2, 0, Color.FromArgb(255, 170, 170, 170))
    bmpBitmap.SetPixel(3, 0, Color.FromArgb(255, 160, 160, 160))
    bmpBitmap.SetPixel(4, 0, Color.FromArgb(255, 150, 150, 150))
    bmpBitmap.SetPixel(iBitmapWidth - 3, 0, Color.FromArgb(255, 150, 150, 150))
    bmpBitmap.SetPixel(iBitmapWidth - 2, 0, Color.FromArgb(255, 160, 160, 160))
    bmpBitmap.SetPixel(iBitmapWidth - 1, 0, Color.FromArgb(255, 170, 170, 170))
    bmpBitmap.SetPixel(iBitmapWidth, 0, Color.FromArgb(255, 180, 180, 180))

    bmpBitmap.SetPixel(0, 1, Color.FromArgb(255, 180, 180, 180))
    bmpBitmap.SetPixel(0, 2, Color.FromArgb(255, 170, 170, 170))
    bmpBitmap.SetPixel(0, 3, Color.FromArgb(255, 160, 160, 160))
    bmpBitmap.SetPixel(0, 4, Color.FromArgb(255, 150, 150, 150))
    bmpBitmap.SetPixel(0, iBitmapHeight - 3, Color.FromArgb(255, 150, 150, 150))
    bmpBitmap.SetPixel(0, iBitmapHeight - 2, Color.FromArgb(255, 160, 160, 160))
    bmpBitmap.SetPixel(0, iBitmapHeight - 1, Color.FromArgb(255, 170, 170, 170))
    bmpBitmap.SetPixel(0, iBitmapHeight, Color.FromArgb(255, 180, 180, 180))

    If (iWidth > 19 Or iHeight > 19) Then
            Dim iHalfWidth As Integer = iWidth \ 2
            Dim iHalfHeight As Integer = iHeight \ 2

      If bCenter Then
        ' Center Center cross
        bmpBitmap.SetPixel(iHalfWidth, iHalfHeight, Color.FromArgb(255, 125, 125, 125))

        bmpBitmap.SetPixel(iHalfWidth, iHalfHeight - 1, Color.FromArgb(255, 160, 160, 160))
        bmpBitmap.SetPixel(iHalfWidth, iHalfHeight - 2, Color.FromArgb(255, 155, 155, 155))
        bmpBitmap.SetPixel(iHalfWidth, iHalfHeight - 3, Color.FromArgb(255, 150, 150, 150))
        bmpBitmap.SetPixel(iHalfWidth, iHalfHeight - 4, Color.FromArgb(255, 145, 145, 145))

        bmpBitmap.SetPixel(iHalfWidth, iHalfHeight + 4, Color.FromArgb(255, 145, 145, 145))
        bmpBitmap.SetPixel(iHalfWidth, iHalfHeight + 3, Color.FromArgb(255, 150, 150, 150))
        bmpBitmap.SetPixel(iHalfWidth, iHalfHeight + 2, Color.FromArgb(255, 155, 155, 155))
        bmpBitmap.SetPixel(iHalfWidth, iHalfHeight + 1, Color.FromArgb(255, 160, 160, 160))

        bmpBitmap.SetPixel(iHalfWidth - 1, iHalfHeight, Color.FromArgb(255, 160, 160, 160))
        bmpBitmap.SetPixel(iHalfWidth - 2, iHalfHeight, Color.FromArgb(255, 155, 155, 155))
        bmpBitmap.SetPixel(iHalfWidth - 3, iHalfHeight, Color.FromArgb(255, 150, 150, 150))
        bmpBitmap.SetPixel(iHalfWidth - 4, iHalfHeight, Color.FromArgb(255, 145, 145, 145))

        bmpBitmap.SetPixel(iHalfWidth + 4, iHalfHeight, Color.FromArgb(255, 145, 145, 145))
        bmpBitmap.SetPixel(iHalfWidth + 3, iHalfHeight, Color.FromArgb(255, 150, 150, 150))
        bmpBitmap.SetPixel(iHalfWidth + 2, iHalfHeight, Color.FromArgb(255, 155, 155, 155))
        bmpBitmap.SetPixel(iHalfWidth + 1, iHalfHeight, Color.FromArgb(255, 160, 160, 160))
      End If

      If bWidthCenter Then
        ' Center width cross
        bmpBitmap.SetPixel(iHalfWidth, 0, Color.FromArgb(255, 125, 125, 125))

        bmpBitmap.SetPixel(iHalfWidth, 1, Color.FromArgb(255, 160, 160, 160))
        bmpBitmap.SetPixel(iHalfWidth, 2, Color.FromArgb(255, 155, 155, 155))
        bmpBitmap.SetPixel(iHalfWidth, 3, Color.FromArgb(255, 150, 150, 150))
        bmpBitmap.SetPixel(iHalfWidth, 4, Color.FromArgb(255, 145, 145, 145))

        bmpBitmap.SetPixel(iHalfWidth, iHeight - 4, Color.FromArgb(255, 145, 145, 145))
        bmpBitmap.SetPixel(iHalfWidth, iHeight - 3, Color.FromArgb(255, 150, 150, 150))
        bmpBitmap.SetPixel(iHalfWidth, iHeight - 2, Color.FromArgb(255, 155, 155, 155))
        bmpBitmap.SetPixel(iHalfWidth, iHeight - 1, Color.FromArgb(255, 160, 160, 160))

        bmpBitmap.SetPixel(iHalfWidth - 1, 0, Color.FromArgb(255, 160, 160, 160))
        bmpBitmap.SetPixel(iHalfWidth - 2, 0, Color.FromArgb(255, 155, 155, 155))
        bmpBitmap.SetPixel(iHalfWidth - 3, 0, Color.FromArgb(255, 150, 150, 150))
        bmpBitmap.SetPixel(iHalfWidth - 4, 0, Color.FromArgb(255, 145, 145, 145))

        bmpBitmap.SetPixel(iHalfWidth + 4, 0, Color.FromArgb(255, 145, 145, 145))
        bmpBitmap.SetPixel(iHalfWidth + 3, 0, Color.FromArgb(255, 150, 150, 150))
        bmpBitmap.SetPixel(iHalfWidth + 2, 0, Color.FromArgb(255, 155, 155, 155))
        bmpBitmap.SetPixel(iHalfWidth + 1, 0, Color.FromArgb(255, 160, 160, 160))
      End If

      If bHeightCenter Then
        ' Center height cross
        bmpBitmap.SetPixel(0, iHalfHeight, Color.FromArgb(255, 125, 125, 125))

        bmpBitmap.SetPixel(0, iHalfHeight + 1, Color.FromArgb(255, 160, 160, 160))
        bmpBitmap.SetPixel(0, iHalfHeight + 2, Color.FromArgb(255, 155, 155, 155))
        bmpBitmap.SetPixel(0, iHalfHeight + 3, Color.FromArgb(255, 150, 150, 150))
        bmpBitmap.SetPixel(0, iHalfHeight + 4, Color.FromArgb(255, 145, 145, 145))

        bmpBitmap.SetPixel(0, iHalfHeight - 4, Color.FromArgb(255, 145, 145, 145))
        bmpBitmap.SetPixel(0, iHalfHeight - 3, Color.FromArgb(255, 150, 150, 150))
        bmpBitmap.SetPixel(0, iHalfHeight - 2, Color.FromArgb(255, 155, 155, 155))
        bmpBitmap.SetPixel(0, iHalfHeight - 1, Color.FromArgb(255, 160, 160, 160))

        bmpBitmap.SetPixel(iWidth - 1, iHalfHeight, Color.FromArgb(255, 160, 160, 160))
        bmpBitmap.SetPixel(iWidth - 2, iHalfHeight, Color.FromArgb(255, 155, 155, 155))
        bmpBitmap.SetPixel(iWidth - 3, iHalfHeight, Color.FromArgb(255, 150, 150, 150))
        bmpBitmap.SetPixel(iWidth - 4, iHalfHeight, Color.FromArgb(255, 145, 145, 145))

        bmpBitmap.SetPixel(4, iHalfHeight, Color.FromArgb(255, 145, 145, 145))
        bmpBitmap.SetPixel(3, iHalfHeight, Color.FromArgb(255, 150, 150, 150))
        bmpBitmap.SetPixel(2, iHalfHeight, Color.FromArgb(255, 155, 155, 155))
        bmpBitmap.SetPixel(1, iHalfHeight, Color.FromArgb(255, 160, 160, 160))
      End If
    End If

    Me.Refresh()
  End Sub

  Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
    Static Dim size As Integer = 10

    size += 1

    CreateGridPiece(size, size, False, True, True)
  End Sub
End Class
